﻿Imports System.Xml
Imports System.IO

Public Class frmMain



    Private Sub createNode(ByVal pID As String, ByVal pName As String, ByVal pPrice As String, ByVal writer As XmlTextWriter)

        'Create the opening tag for each product
        writer.WriteStartElement("Product")

        'Write each product ID
        writer.WriteStartElement("Product_id")
        writer.WriteString(pID)
        writer.WriteEndElement()

        'Write the product name
        writer.WriteStartElement("Product_name")
        writer.WriteString(pName)
        writer.WriteEndElement()

        'Write the product price
        writer.WriteStartElement("Product_price")
        writer.WriteString(pPrice)
        writer.WriteEndElement()

        'Close the products tag
        writer.WriteEndElement()

    End Sub

    Private Sub btnCreate_Click(sender As Object, e As EventArgs) Handles btnCreate.Click

        'Declare the variables
        Dim numProd, i As Integer
        Dim currProd, price As String

        'Choose a filename
        fileName = InputBox("What would you like your XML file to be called?") & ".xml"

        'Enable reading from the XML file
        btnRead.Enabled = True
        btnSearch.Enabled = True
        btnView.Enabled = True

        'Create the XML document
        Dim writer As New XmlTextWriter(fileName, System.Text.Encoding.UTF8)

        'Set the XML document to begin writing
        writer.WriteStartDocument(True)

        ' Set the formatting features of the XML document
        writer.Formatting = Formatting.Indented
        writer.Indentation = 2

        ' Set the opening tag
        writer.WriteStartElement("Table")

        ' Populate the XML document
        numProd = InputBox("How many products do you want to sell?")

        'Get the user to enter in the products and their prices
        For i = 1 To numProd
            currProd = InputBox("Please enter the name of product " & i)
            price = InputBox("What is the price of " & currProd & "?")
            createNode(i, currProd, price, writer)
        Next

        'Finish and close the XML document
        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()

    End Sub

    Private Sub btnRead_Click(sender As Object, e As EventArgs) Handles btnRead.Click

        'Declare the variables
        Dim xmldoc As New XmlDataDocument()
        Dim xmlnode As XmlNodeList
        Dim i As Integer
        Dim str As String
        Dim fs As New FileStream(fileName, FileMode.Open, FileAccess.Read)

        'Load the XML file for reading from
        xmldoc.Load(fs)

        'Find the opening tag of each element
        xmlnode = xmldoc.GetElementsByTagName("Product")

        'Read the elements one by one
        For i = 0 To xmlnode.Count - 1
            xmlnode(i).ChildNodes.Item(0).InnerText.Trim()
            str = xmlnode(i).ChildNodes.Item(0).InnerText.Trim() & "  " & xmlnode(i).ChildNodes.Item(1).InnerText.Trim() & "  " & xmlnode(i).ChildNodes.Item(2).InnerText.Trim()
            MsgBox(str)
        Next

    End Sub

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click

        'Declare the variables
        Dim xmlFile As XmlReader
        xmlFile = XmlReader.Create(fileName, New XmlReaderSettings())
        Dim ds As New DataSet
        Dim dv As DataView
        Dim prodToFind As String

        'Check for the product the user wishes to find
        prodToFind = InputBox("What do you want to find?")

        'Read the file into a dataset
        ds.ReadXml(xmlFile)
        dv = New DataView(ds.Tables(0))
        dv.Sort = "Product_Name"
        Dim index As Integer = dv.Find(prodToFind)

        ' Check whether the product was found or not
        If index = -1 Then
            MsgBox("Item Not Found")
        Else
            MsgBox(dv(index)("Product_Name").ToString() & "  " & dv(index)("Product_Price").ToString())
        End If

    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click

        'Exit the program
        End

    End Sub

    Private Sub btnView_Click(sender As Object, e As EventArgs) Handles btnView.Click

        'Open the new form
        frmFileViewer.Show()
        Me.Hide()

    End Sub
End Class

